#include <fstream>
#include <sched.h>
#include <boost/interprocess/sync/scoped_lock.hpp>
#include <boost/interprocess/sync/interprocess_mutex.hpp>
#include <boost/interprocess/shared_memory_object.hpp>
#include <boost/interprocess/mapped_region.hpp>


using namespace boost::interprocess;

struct my_mutex
{
	boost::interprocess::interprocess_mutex mutex;	
};
struct shm_remove
{
	~shm_remove(){ shared_memory_object::remove("MySharedMemory"); }
};

int main()
{
	if(fork())
	{
		std::ofstream output("output4");
		shm_remove remover;

		shared_memory_object shm(open_or_create
			,"MySharedMemory"
			,read_write
		);

		shm.truncate(sizeof(my_mutex));

		mapped_region region(shm
			,read_write
		);

		void * addr = region.get_address();

		my_mutex * mx = new (addr) my_mutex;

		for(size_t i = 0; i != 100000; ++i)
		{
			scoped_lock<interprocess_mutex> lock(mx->mutex);
			output << "1";
			output.flush();
			sched_yield();
			output << "2";
			output.flush();
		}
	}
	else
	{
		std::ofstream output("output4");
		shared_memory_object shm(open_or_create
			,"MySharedMemory"
			,read_write
		);
		shm_remove remover;
		shm.truncate(sizeof(my_mutex));

		mapped_region region(shm
			,read_write
		);

		void * addr = region.get_address();

		my_mutex * mx = static_cast<my_mutex*>(addr);

		for(size_t i = 0; i != 100000; ++i)
		{
			scoped_lock<interprocess_mutex> lock(mx->mutex);
			output << "3";
			output.flush();
			sched_yield();
			output << "4";
			output.flush();
		}
	}
	return 0;
}
