#include <fstream>
#include <sched.h>
#include <boost/interprocess/sync/scoped_lock.hpp>
#include <boost/interprocess/sync/named_mutex.hpp>

using namespace boost::interprocess;

struct mutex_remove
{
	mutex_remove() { named_mutex::remove("fstream_named_mutex"); }
	~mutex_remove(){ named_mutex::remove("fstream_named_mutex"); }
};

int main()
{
	if(fork())
	{
		std::ofstream output("output5");
		mutex_remove remover;
		named_mutex mutex(open_or_create, "fstream_named_mutex");
		for(size_t i = 0; i != 100000; ++i)
		{
			scoped_lock<named_mutex> lock(mutex);
			output << "1";
			output.flush();
			sched_yield();
			output << "2";
			output.flush();
		}
	}
	else
	{
		std::ofstream output("output5");
		mutex_remove remover;
		named_mutex mutex(open_or_create, "fstream_named_mutex1");
		for(size_t i = 0; i != 100000; ++i)
		{
			scoped_lock<named_mutex> lock(mutex);
			output << "3";
			output.flush();
			sched_yield();
			output << "4";
			output.flush();
		}
	}
	return 0;
}
